<?php
// if this var is not set, we have no config, so get out
if ($webdom=='') {
    header("Location: ../");
    die();
}

/////////////////////////////////////////////
// DB connectivity info
/////////////////////////////////////////////

$mssql_dbhost='localhost\SQLEXPRESS';
$mssql_dbuser='sa';
$mssql_dbpass='sambapos';
$mssql_dbname='SambaPOS4';

/** DEPARTMENT and default WAREHOUSE
 *  The default Warehouse is defined in the Department.
 *  Set the Department Name here to obtain the proper Warehouse
 *  where Inventory Purchases will arrive.
 *  In my setup, the 'Restaurant' department uses the SHOP warehouse
 *  because this is where I receive all products.
 */
$department['Name']='Restaurant';


/** LOCAL WAREHOUSES
 *  I have 2 Warehouses defined that I transfer stock to/from:
 *  The 1st is onsite, and receives all products.
 *  The 2nd is offsite, and is used for stock requests.
 *  I frequently transfer stock from one warehouse to the other.
 *  These are referenced in code as $wh[1]['Name'], $wh[2]['Name'], etc
 */
$w=0;
$wh[++$w]['Name']='SHOP';
$wh[++$w]['Name']='BODEGA';

/** WAREHOUSE TYPES
 *  The above Warehouses are categorized
 *  as a Warehouse Type of 'Local Warehouses'.
 *  This type is referenced in code as $wht[1]['Name']
 *  I also have a Warehouse defined for each Supplier Entity.
 *  These Warehouses have the same name as the Entity and are categorized
 *  as a Warehouse Type of 'Supplier Warehouses'
 *  This type is referenced in code as $wht[2]['Name']
 */
$wt=0;
$wht[++$wt]['Name']='Local Warehouses';
$wht[++$wt]['Name']='Supplier Warehouses';


/**
 *  In my SambaPOS setup I have ensured that the Names
 *  of Supplier Entities, Accounts, and Warehouses are the same.
 *  For simplicity (and personal preference), when we Add an Item to the PURCHASE screen
 *  we'll set the Inventory Doc to have the same Name as the Supplier Warehouse.
 *  This way, when we do Payouts (Account Transactions) our money will
 *  flow to the proper Supplier Account.
 *  If this behavior is undesirable, set the following directive to FALSE.
 *  This directive is used in /zincludes/mssql/itransactions_upd.php and 
 *  disp_purchase.php
 */
$autocreateInventoryDoc=true;

/**
 *  Choose to Auto-Login the SambaPOS User into
 *  the Inventory Sysytem by setting the following to TRUE.
 *  Setting it to FALSE will force a login screen to appear.
 *  If no user is logged into SambaPOS, this value has no meaning
 *  and a login screen will appear anyway.
 *  Additionally, autologin will only take place if the domain matches
 *  the domain set here.  This means if the user is accessing the site
 *  remotely (i.e. www.externaldomain.com), autologin will fail.
 *  Presumably, you only want autologin to function locally, on the
 *  same machine that SambaPOS/DB is running, with the Webservice (i.e. 'localhost').
 *  This could also be '127.0.0.1' (similar to 'localhost') or
 *  the local (static/reserved) IP of the machine (i.e. '192.168.1.100').
 *  Essentially, you would set the URL of the HTML Widget to one of these addresses
 *  (i.e. 'http://localhost'), and set the domain here to the same ('localhost').
 *  We store the logged-in user in the DB under a Program Setting.  The Name of 
 *  this Program Setting needs to be specified here as well.
 */
$autologinSambaUser=true;
$autologinDomain='localhost';
$autologinDBsetting='InvUser';
?>
