<?php
// NOTE: In my SambaPOS setup I have ensured that the Names
// of Supplier Entities, Accounts, and Warehouses are the same.
// For simplicity (and personal preference), when we Add an Item
// we'll set the Inventory Doc to have the same Name as the Supplier Warehouse.
// This way, when we do Payouts (Account Transactions) our money will
// flow to the proper Supplier Account.
// If this behavior is undesirable, remove or comment-out
// the following IF statement (4 lines).
if ($operation=='AddItem' && $autocreateInventoryDoc==true) { // $autocreateInventoryDoc is set in configdb.php
    $iDocId=0;
    $iDocName='';
}

// get Inventory Item Multipler
$multiplier=0;
$cqry = 'SELECT [Name], [BaseUnit], [TransactionUnit], [TransactionUnitMultiplier] FROM [InventoryItems] WHERE [Id]='.$inventoryid;
$records = msexecquery($msdbconn,$cqry);
$rc=count($records);
$ubase=$records[1]['BaseUnit'];
$utx=$records[1]['TransactionUnit'];
$umult=$records[1]['TransactionUnitMultiplier'];
if ($packagetypeid==$ubase) {
    $multiplier=1;
}
if ($packagetypeid==$utx) {
    $multiplier=$umult;
}
if ($multiplier==0) {
    $cqry = 'SELECT [Name], [Multiplier], [DefaultCost] FROM [InventoryItemUnits] WHERE [InventoryItemId]='.$inventoryid;
    $records = msexecquery($msdbconn,$cqry);
    $rc=count($records);
    for ($a=1; $a<=$rc; $a++) {
        if ($packagetypeid==$records[1]['Name']) {
            $multiplier=$records[1]['Multiplier'];
            break;
        }
    }
}


// If an Inventory Document wasn't specified, create a New one.
if ($iDocId==0 && $iDocName=='') {
    $cqry = 'SELECT [Name] FROM [Entities] WHERE [WarehouseId]='.$warehouseid;
    $records = msexecquery($msdbconn,$cqry);
    $rc=count($records);
    $iDocName=$records[1]['Name'];
}

// If the Doc Name is not BLANK, see if we can locate it,
// and if not, create a New Doc
if ($iDocName!='') {
    // Locate the Doc
    $cqry = "SELECT [Id] FROM [InventoryTransactionDocuments] WHERE [Name]='".$iDocName."'";
    $cqry.= " AND [Date]>='".$wpdate."'";
    $records = msexecquery($msdbconn,$cqry);
    $rc=count($records);
    // If the Doc was found, set the DocId
    if($rc>0) {$iDocId=$records[1]['Id'];}
    // If the Doc was NOT found, create a New Doc
    if($rc==0 && $operation=='AddItem') {
        $cqry = '';
        $cqry.='INSERT INTO [InventoryTransactionDocuments] ('."\r\n";
        $cqry.=' [Date]'."\r\n";
        $cqry.=',[Name]'."\r\n";

        $cqry.=') VALUES ('."\r\n";

        $cqry.=' '."'".$dtrequest."'"."\r\n";
        $cqry.=','."'".$iDocName."'"."\r\n";
        $cqry.=')'."\r\n";

        $records = msexecquery($msdbconn,$cqry);
        $rc=count($records);

        $cqry = "SELECT [Id], [Name] FROM [InventoryTransactionDocuments] WHERE [Name]='".$iDocName."'";
        $cqry.= " AND [Date]>='".$wpdate."'";
        $records = msexecquery($msdbconn,$cqry);
        $rc=count($records);

        // Set DocId and DocName variables to the new Doc
        if ($rc>0) {
            $iDocId=$records[1]['Id'];
            $iDocName=$records[1]['Name'];
        } else {
            die("InventoryDocuments SELECT statement returned 0 rows!");
        }
    }
}

if ($operation=='AddItem') {
    $cqry = '';
    $cqry.='INSERT INTO [InventoryTransactions] ('."\r\n";
    $cqry.=' [InventoryTransactionDocumentId]'."\r\n";
    $cqry.=',[InventoryTransactionTypeId]'."\r\n";
    $cqry.=',[SourceWarehouseId]'."\r\n";
    $cqry.=',[TargetWarehouseId]'."\r\n";
    $cqry.=',[Date]'."\r\n";
    $cqry.=',[Unit]'."\r\n";
    $cqry.=',[Multiplier]'."\r\n";
    $cqry.=',[Quantity]'."\r\n";
    $cqry.=',[TotalPrice]'."\r\n";
    $cqry.=',[InventoryItem_Id]'."\r\n";

    $cqry.=') VALUES ('."\r\n";

    $cqry.=' '.$iDocId."\r\n";
    $cqry.=','.$iTxType."\r\n";
    $cqry.=','.$warehouseid."\r\n";
    //$cqry.=",(SELECT [WarehouseId] FROM [Departments] WHERE [Name]='".$department['Name']."')"."\r\n"; // 30
    $cqry.=",".$department['WarehouseId']."\r\n"; // 30
    $cqry.=','."'".$dtrequest."'"."\r\n";
    $cqry.=','."'".$packagetypeid."'"."\r\n";
    $cqry.=','.$multiplier."\r\n";
    $cqry.=','.$quantity."\r\n";
    $cqry.=','.$unitcost*$quantity."\r\n";
    $cqry.=','.$inventoryid."\r\n";
    $cqry.=')'."\r\n";

    $records = msexecquery($msdbconn,$cqry);
    $rc=count($records);
}

if ($operation=='RemoveItem') {
    // get DocId
    $cqry ='SELECT [InventoryTransactionDocumentId] FROM [InventoryTransactions]'."\r\n";
    $cqry.='WHERE [Id]='.$itxid."\r\n";
    $records = msexecquery($msdbconn,$cqry);
    $rc=count($records);
    $iDocId = ($rc>0 ? $records[1]['InventoryTransactionDocumentId'] : 0);

    // DELETE item
    $cqry ='DELETE FROM [InventoryTransactions]'."\r\n";
    $cqry.='WHERE [Id]='.$itxid."\r\n";
    $records = msexecquery($msdbconn,$cqry);
    $rc=count($records);

    if($iDocId!=0) {
        // check to see if there are items left in the Doc
        $cqry = "SELECT [Id] FROM [InventoryTransactions] WHERE [InventoryTransactionDocumentId]=".$iDocId;
        $records = msexecquery($msdbconn,$cqry);
        $rc=count($records);

        if($rc==0) {
            // if no items left in the Doc, DELETE the Doc
            $cqry = "DELETE FROM [InventoryTransactionDocuments] WHERE [Id]=".$iDocId;
            $records = msexecquery($msdbconn,$cqry);
            $rc=count($records);
        }
    }
}

// clear vars
$cqry=null;
$records=null;
$rc=null;
?>